'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var MonacoEditor = require('@monaco-editor/react');
var graphqlLanguageService = require('graphql-language-service');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var MonacoEditor__default = /*#__PURE__*/_interopDefaultLegacy(MonacoEditor);

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);

    if (enumerableOnly) {
      symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }

    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = it.call(o);
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

function devAssert(condition, message) {
  const booleanCondition = Boolean(condition);

  if (!booleanCondition) {
    throw new Error(message);
  }
}

/**
 * Return true if `value` is object-like. A value is object-like if it's not
 * `null` and has a `typeof` result of "object".
 */
function isObjectLike(value) {
  return typeof value == 'object' && value !== null;
}

function invariant(condition, message) {
  const booleanCondition = Boolean(condition);

  if (!booleanCondition) {
    throw new Error(
      message != null ? message : 'Unexpected invariant triggered.',
    );
  }
}

const LineRegExp = /\r\n|[\n\r]/g;
/**
 * Represents a location in a Source.
 */

/**
 * Takes a Source and a UTF-8 character offset, and returns the corresponding
 * line and column as a SourceLocation.
 */
function getLocation(source, position) {
  let lastLineStart = 0;
  let line = 1;

  for (const match of source.body.matchAll(LineRegExp)) {
    typeof match.index === 'number' || invariant(false);

    if (match.index >= position) {
      break;
    }

    lastLineStart = match.index + match[0].length;
    line += 1;
  }

  return {
    line,
    column: position + 1 - lastLineStart,
  };
}

/**
 * Render a helpful description of the location in the GraphQL Source document.
 */

function printLocation(location) {
  return printSourceLocation(
    location.source,
    getLocation(location.source, location.start),
  );
}
/**
 * Render a helpful description of the location in the GraphQL Source document.
 */

function printSourceLocation(source, sourceLocation) {
  const firstLineColumnOffset = source.locationOffset.column - 1;
  const body = ''.padStart(firstLineColumnOffset) + source.body;
  const lineIndex = sourceLocation.line - 1;
  const lineOffset = source.locationOffset.line - 1;
  const lineNum = sourceLocation.line + lineOffset;
  const columnOffset = sourceLocation.line === 1 ? firstLineColumnOffset : 0;
  const columnNum = sourceLocation.column + columnOffset;
  const locationStr = `${source.name}:${lineNum}:${columnNum}\n`;
  const lines = body.split(/\r\n|[\n\r]/g);
  const locationLine = lines[lineIndex]; // Special case for minified documents

  if (locationLine.length > 120) {
    const subLineIndex = Math.floor(columnNum / 80);
    const subLineColumnNum = columnNum % 80;
    const subLines = [];

    for (let i = 0; i < locationLine.length; i += 80) {
      subLines.push(locationLine.slice(i, i + 80));
    }

    return (
      locationStr +
      printPrefixedLines([
        [`${lineNum} |`, subLines[0]],
        ...subLines.slice(1, subLineIndex + 1).map((subLine) => ['|', subLine]),
        ['|', '^'.padStart(subLineColumnNum)],
        ['|', subLines[subLineIndex + 1]],
      ])
    );
  }

  return (
    locationStr +
    printPrefixedLines([
      // Lines specified like this: ["prefix", "string"],
      [`${lineNum - 1} |`, lines[lineIndex - 1]],
      [`${lineNum} |`, locationLine],
      ['|', '^'.padStart(columnNum)],
      [`${lineNum + 1} |`, lines[lineIndex + 1]],
    ])
  );
}

function printPrefixedLines(lines) {
  const existingLines = lines.filter(([_, line]) => line !== undefined);
  const padLen = Math.max(...existingLines.map(([prefix]) => prefix.length));
  return existingLines
    .map(([prefix, line]) => prefix.padStart(padLen) + (line ? ' ' + line : ''))
    .join('\n');
}

/**
 * Custom extensions
 *
 * @remarks
 * Use a unique identifier name for your extension, for example the name of
 * your library or project. Do not use a shortened identifier as this increases
 * the risk of conflicts. We recommend you add at most one extension field,
 * an object which can contain all the values you need.
 */

/**
 * A GraphQLError describes an Error found during the parse, validate, or
 * execute phases of performing a GraphQL operation. In addition to a message
 * and stack trace, it also includes information about the locations in a
 * GraphQL document and/or execution result that correspond to the Error.
 */
class GraphQLError extends Error {
  /**
   * An array of `{ line, column }` locations within the source GraphQL document
   * which correspond to this error.
   *
   * Errors during validation often contain multiple locations, for example to
   * point out two things with the same name. Errors during execution include a
   * single location, the field which produced the error.
   *
   * Enumerable, and appears in the result of JSON.stringify().
   */

  /**
   * An array describing the JSON-path into the execution response which
   * corresponds to this error. Only included for errors during execution.
   *
   * Enumerable, and appears in the result of JSON.stringify().
   */

  /**
   * An array of GraphQL AST Nodes corresponding to this error.
   */

  /**
   * The source GraphQL document for the first location of this error.
   *
   * Note that if this Error represents more than one node, the source may not
   * represent nodes after the first node.
   */

  /**
   * An array of character offsets within the source GraphQL document
   * which correspond to this error.
   */

  /**
   * The original error thrown from a field resolver during execution.
   */

  /**
   * Extension fields to add to the formatted error.
   */
  constructor(
    message,
    nodes,
    source,
    positions,
    path,
    originalError,
    extensions,
  ) {
    var _this$nodes, _nodeLocations$, _ref;

    super(message);
    this.name = 'GraphQLError';
    this.path = path !== null && path !== void 0 ? path : undefined;
    this.originalError =
      originalError !== null && originalError !== void 0
        ? originalError
        : undefined; // Compute list of blame nodes.

    this.nodes = undefinedIfEmpty(
      Array.isArray(nodes) ? nodes : nodes ? [nodes] : undefined,
    );
    const nodeLocations = undefinedIfEmpty(
      (_this$nodes = this.nodes) === null || _this$nodes === void 0
        ? void 0
        : _this$nodes.map((node) => node.loc).filter((loc) => loc != null),
    ); // Compute locations in the source for the given nodes/positions.

    this.source =
      source !== null && source !== void 0
        ? source
        : nodeLocations === null || nodeLocations === void 0
        ? void 0
        : (_nodeLocations$ = nodeLocations[0]) === null ||
          _nodeLocations$ === void 0
        ? void 0
        : _nodeLocations$.source;
    this.positions =
      positions !== null && positions !== void 0
        ? positions
        : nodeLocations === null || nodeLocations === void 0
        ? void 0
        : nodeLocations.map((loc) => loc.start);
    this.locations =
      positions && source
        ? positions.map((pos) => getLocation(source, pos))
        : nodeLocations === null || nodeLocations === void 0
        ? void 0
        : nodeLocations.map((loc) => getLocation(loc.source, loc.start));
    const originalExtensions = isObjectLike(
      originalError === null || originalError === void 0
        ? void 0
        : originalError.extensions,
    )
      ? originalError === null || originalError === void 0
        ? void 0
        : originalError.extensions
      : undefined;
    this.extensions =
      (_ref =
        extensions !== null && extensions !== void 0
          ? extensions
          : originalExtensions) !== null && _ref !== void 0
        ? _ref
        : Object.create(null); // Only properties prescribed by the spec should be enumerable.
    // Keep the rest as non-enumerable.

    Object.defineProperties(this, {
      message: {
        writable: true,
        enumerable: true,
      },
      name: {
        enumerable: false,
      },
      nodes: {
        enumerable: false,
      },
      source: {
        enumerable: false,
      },
      positions: {
        enumerable: false,
      },
      originalError: {
        enumerable: false,
      },
    }); // Include (non-enumerable) stack trace.

    /* c8 ignore start */
    // FIXME: https://github.com/graphql/graphql-js/issues/2317

    if (
      originalError !== null &&
      originalError !== void 0 &&
      originalError.stack
    ) {
      Object.defineProperty(this, 'stack', {
        value: originalError.stack,
        writable: true,
        configurable: true,
      });
    } else if (Error.captureStackTrace) {
      Error.captureStackTrace(this, GraphQLError);
    } else {
      Object.defineProperty(this, 'stack', {
        value: Error().stack,
        writable: true,
        configurable: true,
      });
    }
    /* c8 ignore stop */
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLError';
  }

  toString() {
    let output = this.message;

    if (this.nodes) {
      for (const node of this.nodes) {
        if (node.loc) {
          output += '\n\n' + printLocation(node.loc);
        }
      }
    } else if (this.source && this.locations) {
      for (const location of this.locations) {
        output += '\n\n' + printSourceLocation(this.source, location);
      }
    }

    return output;
  }

  toJSON() {
    const formattedError = {
      message: this.message,
    };

    if (this.locations != null) {
      formattedError.locations = this.locations;
    }

    if (this.path != null) {
      formattedError.path = this.path;
    }

    if (this.extensions != null && Object.keys(this.extensions).length > 0) {
      formattedError.extensions = this.extensions;
    }

    return formattedError;
  }
}

function undefinedIfEmpty(array) {
  return array === undefined || array.length === 0 ? undefined : array;
}

const MAX_ARRAY_LENGTH = 10;
const MAX_RECURSIVE_DEPTH = 2;
/**
 * Used to print values in error messages.
 */

function inspect(value) {
  return formatValue(value, []);
}

function formatValue(value, seenValues) {
  switch (typeof value) {
    case 'string':
      return JSON.stringify(value);

    case 'function':
      return value.name ? `[function ${value.name}]` : '[function]';

    case 'object':
      return formatObjectValue(value, seenValues);

    default:
      return String(value);
  }
}

function formatObjectValue(value, previouslySeenValues) {
  if (value === null) {
    return 'null';
  }

  if (previouslySeenValues.includes(value)) {
    return '[Circular]';
  }

  const seenValues = [...previouslySeenValues, value];

  if (isJSONable(value)) {
    const jsonValue = value.toJSON(); // check for infinite recursion

    if (jsonValue !== value) {
      return typeof jsonValue === 'string'
        ? jsonValue
        : formatValue(jsonValue, seenValues);
    }
  } else if (Array.isArray(value)) {
    return formatArray(value, seenValues);
  }

  return formatObject(value, seenValues);
}

function isJSONable(value) {
  return typeof value.toJSON === 'function';
}

function formatObject(object, seenValues) {
  const entries = Object.entries(object);

  if (entries.length === 0) {
    return '{}';
  }

  if (seenValues.length > MAX_RECURSIVE_DEPTH) {
    return '[' + getObjectTag(object) + ']';
  }

  const properties = entries.map(
    ([key, value]) => key + ': ' + formatValue(value, seenValues),
  );
  return '{ ' + properties.join(', ') + ' }';
}

function formatArray(array, seenValues) {
  if (array.length === 0) {
    return '[]';
  }

  if (seenValues.length > MAX_RECURSIVE_DEPTH) {
    return '[Array]';
  }

  const len = Math.min(MAX_ARRAY_LENGTH, array.length);
  const remaining = array.length - len;
  const items = [];

  for (let i = 0; i < len; ++i) {
    items.push(formatValue(array[i], seenValues));
  }

  if (remaining === 1) {
    items.push('... 1 more item');
  } else if (remaining > 1) {
    items.push(`... ${remaining} more items`);
  }

  return '[' + items.join(', ') + ']';
}

function getObjectTag(object) {
  const tag = Object.prototype.toString
    .call(object)
    .replace(/^\[object /, '')
    .replace(/]$/, '');

  if (tag === 'Object' && typeof object.constructor === 'function') {
    const name = object.constructor.name;

    if (typeof name === 'string' && name !== '') {
      return name;
    }
  }

  return tag;
}

/**
 * A replacement for instanceof which includes an error warning when multi-realm
 * constructors are detected.
 * See: https://expressjs.com/en/advanced/best-practice-performance.html#set-node_env-to-production
 * See: https://webpack.js.org/guides/production/
 */

const instanceOf =
  /* c8 ignore next 5 */
  // FIXME: https://github.com/graphql/graphql-js/issues/2317
  process.env.NODE_ENV === 'production'
    ? function instanceOf(value, constructor) {
        return value instanceof constructor;
      }
    : function instanceOf(value, constructor) {
        if (value instanceof constructor) {
          return true;
        }

        if (typeof value === 'object' && value !== null) {
          var _value$constructor;

          // Prefer Symbol.toStringTag since it is immune to minification.
          const className = constructor.prototype[Symbol.toStringTag];
          const valueClassName = // We still need to support constructor's name to detect conflicts with older versions of this library.
            Symbol.toStringTag in value // @ts-expect-error TS bug see, https://github.com/microsoft/TypeScript/issues/38009
              ? value[Symbol.toStringTag]
              : (_value$constructor = value.constructor) === null ||
                _value$constructor === void 0
              ? void 0
              : _value$constructor.name;

          if (className === valueClassName) {
            const stringifiedValue = inspect(value);
            throw new Error(`Cannot use ${className} "${stringifiedValue}" from another module or realm.

Ensure that there is only one instance of "graphql" in the node_modules
directory. If different versions of "graphql" are the dependencies of other
relied on modules, use "resolutions" to ensure only one version is installed.

https://yarnpkg.com/en/docs/selective-version-resolutions

Duplicate "graphql" modules cannot be used at the same time since different
versions may have different capabilities and behavior. The data from one
version used in the function from another could produce confusing and
spurious results.`);
          }
        }

        return false;
      };

/**
 * ```
 * WhiteSpace ::
 *   - "Horizontal Tab (U+0009)"
 *   - "Space (U+0020)"
 * ```
 * @internal
 */
/**
 * ```
 * Digit :: one of
 *   - `0` `1` `2` `3` `4` `5` `6` `7` `8` `9`
 * ```
 * @internal
 */

function isDigit(code) {
  return code >= 0x0030 && code <= 0x0039;
}
/**
 * ```
 * Letter :: one of
 *   - `A` `B` `C` `D` `E` `F` `G` `H` `I` `J` `K` `L` `M`
 *   - `N` `O` `P` `Q` `R` `S` `T` `U` `V` `W` `X` `Y` `Z`
 *   - `a` `b` `c` `d` `e` `f` `g` `h` `i` `j` `k` `l` `m`
 *   - `n` `o` `p` `q` `r` `s` `t` `u` `v` `w` `x` `y` `z`
 * ```
 * @internal
 */

function isLetter(code) {
  return (
    (code >= 0x0061 && code <= 0x007a) || // A-Z
    (code >= 0x0041 && code <= 0x005a) // a-z
  );
}
/**
 * ```
 * NameStart ::
 *   - Letter
 *   - `_`
 * ```
 * @internal
 */

function isNameStart(code) {
  return isLetter(code) || code === 0x005f;
}
/**
 * ```
 * NameContinue ::
 *   - Letter
 *   - Digit
 *   - `_`
 * ```
 * @internal
 */

function isNameContinue(code) {
  return isLetter(code) || isDigit(code) || code === 0x005f;
}

/**
 * Creates an object map with the same keys as `map` and values generated by
 * running each value of `map` thru `fn`.
 */
function mapValue(map, fn) {
  const result = Object.create(null);

  for (const key of Object.keys(map)) {
    result[key] = fn(map[key], key);
  }

  return result;
}

function toObjMap(obj) {
  if (obj == null) {
    return Object.create(null);
  }

  if (Object.getPrototypeOf(obj) === null) {
    return obj;
  }

  const map = Object.create(null);

  for (const [key, value] of Object.entries(obj)) {
    map[key] = value;
  }

  return map;
}

/**
 * Creates a keyed JS object from an array, given a function to produce the keys
 * and a function to produce the values from each item in the array.
 * ```ts
 * const phoneBook = [
 *   { name: 'Jon', num: '555-1234' },
 *   { name: 'Jenny', num: '867-5309' }
 * ]
 *
 * // { Jon: '555-1234', Jenny: '867-5309' }
 * const phonesByName = keyValMap(
 *   phoneBook,
 *   entry => entry.name,
 *   entry => entry.num
 * )
 * ```
 */
function keyValMap(list, keyFn, valFn) {
  const result = Object.create(null);

  for (const item of list) {
    result[keyFn(item)] = valFn(item);
  }

  return result;
}

/**
 * Upholds the spec rules about naming.
 */

function assertName(name) {
  name != null || devAssert(false, 'Must provide name.');
  typeof name === 'string' || devAssert(false, 'Expected name to be a string.');

  if (name.length === 0) {
    throw new GraphQLError('Expected name to be a non-empty string.');
  }

  for (let i = 1; i < name.length; ++i) {
    if (!isNameContinue(name.charCodeAt(i))) {
      throw new GraphQLError(
        `Names must only contain [_a-zA-Z0-9] but "${name}" does not.`,
      );
    }
  }

  if (!isNameStart(name.charCodeAt(0))) {
    throw new GraphQLError(
      `Names must start with [_a-zA-Z] but "${name}" does not.`,
    );
  }

  return name;
}

function isObjectType(type) {
  return instanceOf(type, GraphQLObjectType);
}
function isInterfaceType(type) {
  return instanceOf(type, GraphQLInterfaceType);
}
/**
 * Used while defining GraphQL types to allow for circular references in
 * otherwise immutable type definitions.
 */

function resolveReadonlyArrayThunk(thunk) {
  return typeof thunk === 'function' ? thunk() : thunk;
}

function resolveObjMapThunk(thunk) {
  return typeof thunk === 'function' ? thunk() : thunk;
}

/**
 * Object Type Definition
 *
 * Almost all of the GraphQL types you define will be object types. Object types
 * have a name, but most importantly describe their fields.
 *
 * Example:
 *
 * ```ts
 * const AddressType = new GraphQLObjectType({
 *   name: 'Address',
 *   fields: {
 *     street: { type: GraphQLString },
 *     number: { type: GraphQLInt },
 *     formatted: {
 *       type: GraphQLString,
 *       resolve(obj) {
 *         return obj.number + ' ' + obj.street
 *       }
 *     }
 *   }
 * });
 * ```
 *
 * When two types need to refer to each other, or a type needs to refer to
 * itself in a field, you can use a function expression (aka a closure or a
 * thunk) to supply the fields lazily.
 *
 * Example:
 *
 * ```ts
 * const PersonType = new GraphQLObjectType({
 *   name: 'Person',
 *   fields: () => ({
 *     name: { type: GraphQLString },
 *     bestFriend: { type: PersonType },
 *   })
 * });
 * ```
 */
class GraphQLObjectType {
  constructor(config) {
    var _config$extensionASTN2;

    this.name = assertName(config.name);
    this.description = config.description;
    this.isTypeOf = config.isTypeOf;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN2 = config.extensionASTNodes) !== null &&
      _config$extensionASTN2 !== void 0
        ? _config$extensionASTN2
        : [];

    this._fields = () => defineFieldMap(config);

    this._interfaces = () => defineInterfaces(config);

    config.isTypeOf == null ||
      typeof config.isTypeOf === 'function' ||
      devAssert(
        false,
        `${this.name} must provide "isTypeOf" as a function, ` +
          `but got: ${inspect(config.isTypeOf)}.`,
      );
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLObjectType';
  }

  getFields() {
    if (typeof this._fields === 'function') {
      this._fields = this._fields();
    }

    return this._fields;
  }

  getInterfaces() {
    if (typeof this._interfaces === 'function') {
      this._interfaces = this._interfaces();
    }

    return this._interfaces;
  }

  toConfig() {
    return {
      name: this.name,
      description: this.description,
      interfaces: this.getInterfaces(),
      fields: fieldsToFieldsConfig(this.getFields()),
      isTypeOf: this.isTypeOf,
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
    };
  }

  toString() {
    return this.name;
  }

  toJSON() {
    return this.toString();
  }
}

function defineInterfaces(config) {
  var _config$interfaces;

  const interfaces = resolveReadonlyArrayThunk(
    (_config$interfaces = config.interfaces) !== null &&
      _config$interfaces !== void 0
      ? _config$interfaces
      : [],
  );
  Array.isArray(interfaces) ||
    devAssert(
      false,
      `${config.name} interfaces must be an Array or a function which returns an Array.`,
    );
  return interfaces;
}

function defineFieldMap(config) {
  const fieldMap = resolveObjMapThunk(config.fields);
  isPlainObj(fieldMap) ||
    devAssert(
      false,
      `${config.name} fields must be an object with field names as keys or a function which returns such an object.`,
    );
  return mapValue(fieldMap, (fieldConfig, fieldName) => {
    var _fieldConfig$args;

    isPlainObj(fieldConfig) ||
      devAssert(
        false,
        `${config.name}.${fieldName} field config must be an object.`,
      );
    fieldConfig.resolve == null ||
      typeof fieldConfig.resolve === 'function' ||
      devAssert(
        false,
        `${config.name}.${fieldName} field resolver must be a function if ` +
          `provided, but got: ${inspect(fieldConfig.resolve)}.`,
      );
    const argsConfig =
      (_fieldConfig$args = fieldConfig.args) !== null &&
      _fieldConfig$args !== void 0
        ? _fieldConfig$args
        : {};
    isPlainObj(argsConfig) ||
      devAssert(
        false,
        `${config.name}.${fieldName} args must be an object with argument names as keys.`,
      );
    return {
      name: assertName(fieldName),
      description: fieldConfig.description,
      type: fieldConfig.type,
      args: defineArguments(argsConfig),
      resolve: fieldConfig.resolve,
      subscribe: fieldConfig.subscribe,
      deprecationReason: fieldConfig.deprecationReason,
      extensions: toObjMap(fieldConfig.extensions),
      astNode: fieldConfig.astNode,
    };
  });
}

function defineArguments(config) {
  return Object.entries(config).map(([argName, argConfig]) => ({
    name: assertName(argName),
    description: argConfig.description,
    type: argConfig.type,
    defaultValue: argConfig.defaultValue,
    deprecationReason: argConfig.deprecationReason,
    extensions: toObjMap(argConfig.extensions),
    astNode: argConfig.astNode,
  }));
}

function isPlainObj(obj) {
  return isObjectLike(obj) && !Array.isArray(obj);
}

function fieldsToFieldsConfig(fields) {
  return mapValue(fields, (field) => ({
    description: field.description,
    type: field.type,
    args: argsToArgsConfig(field.args),
    resolve: field.resolve,
    subscribe: field.subscribe,
    deprecationReason: field.deprecationReason,
    extensions: field.extensions,
    astNode: field.astNode,
  }));
}
/**
 * @internal
 */

function argsToArgsConfig(args) {
  return keyValMap(
    args,
    (arg) => arg.name,
    (arg) => ({
      description: arg.description,
      type: arg.type,
      defaultValue: arg.defaultValue,
      deprecationReason: arg.deprecationReason,
      extensions: arg.extensions,
      astNode: arg.astNode,
    }),
  );
}

/**
 * Interface Type Definition
 *
 * When a field can return one of a heterogeneous set of types, a Interface type
 * is used to describe what types are possible, what fields are in common across
 * all types, as well as a function to determine which type is actually used
 * when the field is resolved.
 *
 * Example:
 *
 * ```ts
 * const EntityType = new GraphQLInterfaceType({
 *   name: 'Entity',
 *   fields: {
 *     name: { type: GraphQLString }
 *   }
 * });
 * ```
 */
class GraphQLInterfaceType {
  constructor(config) {
    var _config$extensionASTN3;

    this.name = assertName(config.name);
    this.description = config.description;
    this.resolveType = config.resolveType;
    this.extensions = toObjMap(config.extensions);
    this.astNode = config.astNode;
    this.extensionASTNodes =
      (_config$extensionASTN3 = config.extensionASTNodes) !== null &&
      _config$extensionASTN3 !== void 0
        ? _config$extensionASTN3
        : [];
    this._fields = defineFieldMap.bind(undefined, config);
    this._interfaces = defineInterfaces.bind(undefined, config);
    config.resolveType == null ||
      typeof config.resolveType === 'function' ||
      devAssert(
        false,
        `${this.name} must provide "resolveType" as a function, ` +
          `but got: ${inspect(config.resolveType)}.`,
      );
  }

  get [Symbol.toStringTag]() {
    return 'GraphQLInterfaceType';
  }

  getFields() {
    if (typeof this._fields === 'function') {
      this._fields = this._fields();
    }

    return this._fields;
  }

  getInterfaces() {
    if (typeof this._interfaces === 'function') {
      this._interfaces = this._interfaces();
    }

    return this._interfaces;
  }

  toConfig() {
    return {
      name: this.name,
      description: this.description,
      interfaces: this.getInterfaces(),
      fields: fieldsToFieldsConfig(this.getFields()),
      resolveType: this.resolveType,
      extensions: this.extensions,
      astNode: this.astNode,
      extensionASTNodes: this.extensionASTNodes,
    };
  }

  toString() {
    return this.name;
  }

  toJSON() {
    return this.toString();
  }
}

function removeFalsey(obj) {
  return !!obj;
}
function locToRange(loc) {
  return {
    startLineNumber: loc.startToken.line,
    startColumn: loc.startToken.column,
    endLineNumber: loc.endToken.line + 1,
    // Because GraphQL starts with 0, and Monaco starts with 1
    endColumn: loc.endToken.column
  };
}
var emptyLocation = {
  startLineNumber: 0,
  startColumn: 0,
  endLineNumber: 0,
  endColumn: 0
};
var coreDiagnosticsSource = {
  forDocument: function forDocument(_ref) {
    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var model, document, languageService;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              model = _ref.model, document = _ref.document, languageService = _ref.languageService;
              return _context.abrupt("return", languageService.getDiagnostics(model.uri.toString(), document).then(function (diag) {
                return diag.map(toMarkerData);
              }).catch(function (e) {
                if ('message' in e && 'locations' in e) {
                  return [toMarkerData({
                    severity: graphqlLanguageService.DIAGNOSTIC_SEVERITY.Error,
                    message: e.message,
                    source: 'GraphQL: Syntax',
                    range: graphqlLanguageService.getRange(e.locations[0], document)
                  })];
                } else {
                  console.warn("GraphQL getDiagnostics failed unexpected error: ", e);
                  return [];
                }
              }));

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }
};
var coreDefinitionSource = {
  forNode: function forNode(_ref2) {
    var schema = _ref2.schema,
        model = _ref2.model,
        token = _ref2.token;

    if (token.state && token.state.kind === 'NamedType' && token.state.name) {
      var type = schema.getType(token.state.name);

      if (type && type.astNode && type.astNode.loc) {
        return [{
          range: {
            startLineNumber: type.astNode.loc.startToken.line,
            startColumn: type.astNode.loc.startToken.column,
            endLineNumber: type.astNode.loc.endToken.line + 1,
            endColumn: type.astNode.loc.endToken.column
          },
          uri: model.uri
        }];
      }
    }

    return [];
  }
};
var coreHoverSource = {
  forNode: function forNode(_ref3) {
    var schema = _ref3.schema,
        document = _ref3.document,
        position = _ref3.position,
        token = _ref3.token;
    return {
      value: graphqlLanguageService.getHoverInformation(schema, document, position, token)
    };
  }
};
var debugHoverSource = {
  forNode: function forNode(_ref4) {
    var token = _ref4.token;
    return {
      value: '```json\n' + JSON.stringify(token.state, null, 2) + '\n```'
    };
  }
};
function toGraphQLPosition(position) {
  return new graphqlLanguageService.Position(position.lineNumber - 1, position.column - 1);
}
function toMarkerData(diagnostic) {
  return {
    startLineNumber: diagnostic.range.start.line + 1,
    endLineNumber: diagnostic.range.end.line + 1,
    startColumn: diagnostic.range.start.character + 1,
    endColumn: diagnostic.range.end.character,
    message: diagnostic.message,
    severity: 5,
    // severity: toMonacoSeverity(diagnostic.severity),
    code: diagnostic.code || undefined
  };
}
function toMonacoRange(range) {
  return {
    startLineNumber: range.start.line + 1,
    startColumn: range.start.character + 1,
    endLineNumber: range.end.line + 1,
    endColumn: range.end.character + 1
  };
}
function showWidgetInPosition(editorInstance, position, htmlElement) {
  editorInstance.changeViewZones(function (changeAccessor) {
    changeAccessor.addZone({
      afterLineNumber: position.line + 1,
      heightInPx: 60,
      domNode: htmlElement
    });
  });
}

var EnrichedLanguageService = /*#__PURE__*/function (_LanguageService) {
  _inherits(EnrichedLanguageService, _LanguageService);

  var _super = _createSuper(EnrichedLanguageService);

  function EnrichedLanguageService() {
    _classCallCheck(this, EnrichedLanguageService);

    return _super.apply(this, arguments);
  }

  _createClass(EnrichedLanguageService, [{
    key: "getNodeAtPosition",
    value: function () {
      var _getNodeAtPosition = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(schema, document, position) {
        var token;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!schema) {
                  _context.next = 4;
                  break;
                }

                token = graphqlLanguageService.getTokenAtPosition(document, position);

                if (!token) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt("return", token);

              case 4:
                return _context.abrupt("return", null);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function getNodeAtPosition(_x, _x2, _x3) {
        return _getNodeAtPosition.apply(this, arguments);
      }

      return getNodeAtPosition;
    }()
  }, {
    key: "buildBridgeForProviders",
    value: function () {
      var _buildBridgeForProviders = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(model, position) {
        var graphQLPosition, document, schema, tokenAtPosition;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                graphQLPosition = toGraphQLPosition(position);
                document = model.getValue();
                _context2.next = 4;
                return this.getSchema();

              case 4:
                schema = _context2.sent;

                if (schema) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt("return", null);

              case 7:
                _context2.next = 9;
                return this.getNodeAtPosition(schema, document, graphQLPosition);

              case 9:
                tokenAtPosition = _context2.sent;

                if (tokenAtPosition) {
                  _context2.next = 12;
                  break;
                }

                return _context2.abrupt("return", null);

              case 12:
                return _context2.abrupt("return", {
                  languageService: this,
                  position: graphQLPosition,
                  document: document,
                  schema: schema,
                  token: tokenAtPosition,
                  model: model
                });

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function buildBridgeForProviders(_x4, _x5) {
        return _buildBridgeForProviders.apply(this, arguments);
      }

      return buildBridgeForProviders;
    }()
  }, {
    key: "getDefinitionProvider",
    value: function getDefinitionProvider(rawSources) {
      var _this = this;

      var sources = [].concat(_toConsumableArray(rawSources), [coreDefinitionSource]);
      return {
        provideDefinition: function () {
          var _provideDefinition = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(model, position) {
            var _ref;

            var bridge, nestedArrays, items;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _context3.next = 2;
                    return _this.buildBridgeForProviders(model, position);

                  case 2:
                    bridge = _context3.sent;

                    if (bridge) {
                      _context3.next = 5;
                      break;
                    }

                    return _context3.abrupt("return", []);

                  case 5:
                    _context3.next = 7;
                    return Promise.all(sources.map(function (source) {
                      return source.forNode(bridge);
                    }));

                  case 7:
                    nestedArrays = _context3.sent.filter(Boolean);
                    items = (_ref = []).concat.apply(_ref, _toConsumableArray(nestedArrays));
                    return _context3.abrupt("return", items);

                  case 10:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3);
          }));

          function provideDefinition(_x6, _x7) {
            return _provideDefinition.apply(this, arguments);
          }

          return provideDefinition;
        }()
      };
    }
  }, {
    key: "getHoverProvider",
    value: function getHoverProvider(rawSources) {
      var _this2 = this;

      var sources = [].concat(_toConsumableArray(rawSources), [coreHoverSource]);
      return {
        provideHover: function () {
          var _provideHover = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(model, position) {
            var info, contents;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    _context5.next = 2;
                    return _this2.buildBridgeForProviders(model, position);

                  case 2:
                    info = _context5.sent;

                    if (info) {
                      _context5.next = 5;
                      break;
                    }

                    return _context5.abrupt("return");

                  case 5:
                    _context5.next = 7;
                    return Promise.all(sources.map( /*#__PURE__*/function () {
                      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(source) {
                        return regeneratorRuntime.wrap(function _callee4$(_context4) {
                          while (1) {
                            switch (_context4.prev = _context4.next) {
                              case 0:
                                _context4.prev = 0;
                                _context4.next = 3;
                                return source.forNode(info);

                              case 3:
                                return _context4.abrupt("return", _context4.sent);

                              case 6:
                                _context4.prev = 6;
                                _context4.t0 = _context4["catch"](0);
                                return _context4.abrupt("return", null);

                              case 9:
                              case "end":
                                return _context4.stop();
                            }
                          }
                        }, _callee4, null, [[0, 6]]);
                      }));

                      return function (_x10) {
                        return _ref2.apply(this, arguments);
                      };
                    }()));

                  case 7:
                    contents = _context5.sent;
                    return _context5.abrupt("return", {
                      contents: contents.filter(removeFalsey),
                      range: toMonacoRange(graphqlLanguageService.getRange({
                        column: info.position.character,
                        line: info.position.line + 1
                      }, info.document))
                    });

                  case 9:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5);
          }));

          function provideHover(_x8, _x9) {
            return _provideHover.apply(this, arguments);
          }

          return provideHover;
        }()
      };
    }
  }, {
    key: "handleDecorations",
    value: function () {
      var _handleDecorations = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(decorationSources, model, monacoInstance, editorInstance) {
        var _iterator, _step, source;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _iterator = _createForOfIteratorHelper(decorationSources);

                try {
                  for (_iterator.s(); !(_step = _iterator.n()).done;) {
                    source = _step.value;
                    source.forDocument({
                      monaco: monacoInstance,
                      editor: editorInstance,
                      document: model.getValue(),
                      model: model,
                      languageService: this
                    });
                  }
                } catch (err) {
                  _iterator.e(err);
                } finally {
                  _iterator.f();
                }

              case 2:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function handleDecorations(_x11, _x12, _x13, _x14) {
        return _handleDecorations.apply(this, arguments);
      }

      return handleDecorations;
    }()
  }, {
    key: "handleDiagnostics",
    value: function () {
      var _handleDiagnostics = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(rawDiagnosticsSources, model, monacoInstance) {
        var _this3 = this,
            _ref4;

        var diagnosticsSources, nestedArrays, markerData;
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                diagnosticsSources = [].concat(_toConsumableArray(rawDiagnosticsSources), [coreDiagnosticsSource]);
                _context8.next = 3;
                return Promise.all(diagnosticsSources.map( /*#__PURE__*/function () {
                  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(source) {
                    return regeneratorRuntime.wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            _context7.prev = 0;
                            _context7.next = 3;
                            return source.forDocument({
                              languageService: _this3,
                              model: model,
                              document: model.getValue().toString()
                            });

                          case 3:
                            return _context7.abrupt("return", _context7.sent);

                          case 6:
                            _context7.prev = 6;
                            _context7.t0 = _context7["catch"](0);
                            return _context7.abrupt("return", null);

                          case 9:
                          case "end":
                            return _context7.stop();
                        }
                      }
                    }, _callee7, null, [[0, 6]]);
                  }));

                  return function (_x18) {
                    return _ref3.apply(this, arguments);
                  };
                }()));

              case 3:
                nestedArrays = _context8.sent.filter(removeFalsey);
                markerData = (_ref4 = []).concat.apply(_ref4, _toConsumableArray(nestedArrays));
                monacoInstance.editor.setModelMarkers(model, 'graphql', markerData);

              case 6:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8);
      }));

      function handleDiagnostics(_x15, _x16, _x17) {
        return _handleDiagnostics.apply(this, arguments);
      }

      return handleDiagnostics;
    }()
  }, {
    key: "getModelChangeHandler",
    value: function getModelChangeHandler() {
      var _this4 = this;

      return /*#__PURE__*/function () {
        var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(editorInstance, monacoInstance, diagnosticsSources, decorationsSources) {
          var model;
          return regeneratorRuntime.wrap(function _callee9$(_context9) {
            while (1) {
              switch (_context9.prev = _context9.next) {
                case 0:
                  model = editorInstance.getModel();

                  if (model) {
                    _context9.next = 3;
                    break;
                  }

                  return _context9.abrupt("return");

                case 3:
                  _context9.next = 5;
                  return Promise.all([_this4.handleDiagnostics(diagnosticsSources, model, monacoInstance), _this4.handleDecorations(decorationsSources, model, monacoInstance, editorInstance)]);

                case 5:
                case "end":
                  return _context9.stop();
              }
            }
          }, _callee9);
        }));

        return function (_x19, _x20, _x21, _x22) {
          return _ref5.apply(this, arguments);
        };
      }();
    }
  }, {
    key: "trySchema",
    value: function trySchema(sdl) {
      var _this5 = this;

      // XX-DOTAN: In case of an issue with the schema parsing, we'll get the error through
      // the Marker, and we can safely ignore it here.
      // eslint-disable-next-line @typescript-eslint/no-empty-function
      return this.setSchema(sdl).then(function () {
        return _this5.getSchema();
      });
    }
  }]);

  return EnrichedLanguageService;
}(graphqlLanguageService.LanguageService);

var useSchemaServices = function useSchemaServices() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var _React$useState = React__default["default"].useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      editorRef = _React$useState2[0],
      setEditor = _React$useState2[1];

  var _React$useState3 = React__default["default"].useState(null),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      monacoRef = _React$useState4[0],
      setMonaco = _React$useState4[1];

  var languageService = React__default["default"].useMemo(function () {
    return options.sharedLanguageService || new EnrichedLanguageService({
      schemaString: options.schema,
      schemaConfig: {
        buildSchemaOptions: {
          assumeValid: true,
          assumeValidSDL: true
        }
      }
    });
  }, [options.sharedLanguageService]);
  React__default["default"].useEffect(function () {
    if (monacoRef && editorRef) {
      if (options.keyboardShortcuts) {
        var _iterator = _createForOfIteratorHelper(options.keyboardShortcuts(editorRef, monacoRef)),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var action = _step.value;
            editorRef.addAction(action);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }

      var _iterator2 = _createForOfIteratorHelper(options.actions || []),
          _step2;

      try {
        var _loop = function _loop() {
          var action = _step2.value;
          editorRef.addAction({
            id: action.id,
            label: action.label,
            keybindings: action.keybindings,
            contextMenuGroupId: action.contextMenuGroupId || 'navigation',
            contextMenuOrder: action.contextMenuOrder,
            run: function () {
              var _run = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(editor) {
                var model, position, bridge;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        model = editor.getModel();
                        position = editor.getPosition();

                        if (!(model && position)) {
                          _context.next = 7;
                          break;
                        }

                        _context.next = 5;
                        return languageService.buildBridgeForProviders(model, position);

                      case 5:
                        bridge = _context.sent;

                        if (bridge) {
                          action.onRun({
                            editor: editorRef,
                            monaco: monacoRef,
                            bridge: bridge
                          });
                        }

                      case 7:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              function run(_x) {
                return _run.apply(this, arguments);
              }

              return run;
            }()
          });
        };

        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          _loop();
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      var handler = languageService.getModelChangeHandler();
      handler(editorRef, monacoRef, options.diagnosticsProviders || [], options.decorationsProviders || []);
      var onChangeDisposable = editorRef.onDidChangeModelContent(function () {
        return handler(editorRef, monacoRef, options.diagnosticsProviders || [], options.decorationsProviders || []);
      });
      var definitionProviderDisposable = monacoRef.languages.registerDefinitionProvider('graphql', languageService.getDefinitionProvider(options.definitionProviders || []));
      var hoverDisposable = monacoRef.languages.registerHoverProvider('graphql', languageService.getHoverProvider(options.hoverProviders || []));
      return function () {
        hoverDisposable && hoverDisposable.dispose();
        definitionProviderDisposable && definitionProviderDisposable.dispose();
        onChangeDisposable && onChangeDisposable.dispose();
      };
    } // eslint-disable-next-line @typescript-eslint/no-empty-function


    return function () {};
  }, [editorRef, monacoRef]);
  return {
    setEditor: setEditor,
    setMonaco: setMonaco,
    editorRef: editorRef,
    monacoRef: monacoRef,
    languageService: languageService,
    setSchema: function setSchema(newValue) {
      return languageService.trySchema(newValue);
    },
    editorApi: {
      jumpToType: function jumpToType(typeName) {
        languageService.getSchema().then(function (schema) {
          if (schema) {
            var _type$astNode;

            var type = schema.getType(typeName);

            if (type !== null && type !== void 0 && (_type$astNode = type.astNode) !== null && _type$astNode !== void 0 && _type$astNode.loc) {
              var range = locToRange(type.astNode.loc);
              editorRef === null || editorRef === void 0 ? void 0 : editorRef.setSelection(range);
              editorRef === null || editorRef === void 0 ? void 0 : editorRef.revealPositionInCenter({
                column: 0,
                lineNumber: range.startLineNumber
              }, 0);
            }
          }
        });
      },
      jumpToField: function jumpToField(typeName, fieldName) {
        languageService.getSchema().then(function (schema) {
          if (schema) {
            var type = schema.getType(typeName);

            if (type && (isObjectType(type) || isInterfaceType(type))) {
              var _field$astNode;

              var field = type.getFields()[fieldName];

              if (field !== null && field !== void 0 && (_field$astNode = field.astNode) !== null && _field$astNode !== void 0 && _field$astNode.loc) {
                var range = locToRange(field.astNode.loc);
                editorRef === null || editorRef === void 0 ? void 0 : editorRef.setSelection(range);
                editorRef === null || editorRef === void 0 ? void 0 : editorRef.revealPositionInCenter({
                  column: 0,
                  lineNumber: range.startLineNumber
                }, 0);
              }
            }
          }
        });
      },
      deselect: function deselect() {
        return editorRef === null || editorRef === void 0 ? void 0 : editorRef.setSelection(emptyLocation);
      }
    }
  };
};

function BaseSchemaEditor(props, ref) {
  var _useSchemaServices = useSchemaServices(props),
      languageService = _useSchemaServices.languageService,
      setMonaco = _useSchemaServices.setMonaco,
      setEditor = _useSchemaServices.setEditor,
      editorApi = _useSchemaServices.editorApi,
      editorRef = _useSchemaServices.editorRef,
      setSchema = _useSchemaServices.setSchema;

  React.useImperativeHandle(ref, function () {
    return editorApi;
  }, [editorRef, languageService]);
  React.useEffect(function () {
    if (languageService && props.onLanguageServiceReady) {
      props.onLanguageServiceReady(languageService);
    }
  }, [languageService, props.onLanguageServiceReady]);

  var _useState = React.useState(),
      _useState2 = _slicedToArray(_useState, 2),
      onBlurHandler = _useState2[0],
      setOnBlurSubscription = _useState2[1];

  React.useEffect(function () {
    if (editorRef && props.onBlur) {
      onBlurHandler === null || onBlurHandler === void 0 ? void 0 : onBlurHandler.dispose();
      var subscription = editorRef.onDidBlurEditorText(function () {
        var _props$onBlur;

        (_props$onBlur = props.onBlur) === null || _props$onBlur === void 0 ? void 0 : _props$onBlur.call(props, editorRef.getValue() || '');
      });
      setOnBlurSubscription(subscription);
    }
  }, [props.onBlur, editorRef]);
  var handleBeforeMount = React.useCallback(function (monaco) {
    var _props$beforeMount;

    setMonaco(monaco);
    (_props$beforeMount = props.beforeMount) === null || _props$beforeMount === void 0 ? void 0 : _props$beforeMount.call(props, monaco);
  }, [props.beforeMount]);
  var handleMount = React.useCallback(function (editor, monaco) {
    var _props$onMount;

    setEditor(editor);
    (_props$onMount = props.onMount) === null || _props$onMount === void 0 ? void 0 : _props$onMount.call(props, editor, monaco);
  }, [props.onMount]);
  var handleChange = React.useCallback( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(newValue, ev) {
      var _props$onChange;

      var _schema, _props$onSchemaChange, error;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, newValue, ev);

              if (newValue) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return");

            case 3:
              _context.prev = 3;
              _context.next = 6;
              return setSchema(newValue);

            case 6:
              _schema = _context.sent;

              if (_schema) {
                (_props$onSchemaChange = props.onSchemaChange) === null || _props$onSchemaChange === void 0 ? void 0 : _props$onSchemaChange.call(props, _schema, newValue);
              }

              _context.next = 16;
              break;

            case 10:
              _context.prev = 10;
              _context.t0 = _context["catch"](3);

              if (props.onSchemaError) {
                _context.next = 14;
                break;
              }

              return _context.abrupt("return");

            case 14:
              error = _context.t0 instanceof GraphQLError ? _context.t0 : new GraphQLError(_context.t0.message, undefined, undefined, undefined, undefined, _context.t0);
              props.onSchemaError([error], newValue, languageService);

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[3, 10]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }(), [props.onChange, props.onSchemaChange, props.onSchemaError]);
  return /*#__PURE__*/React__default["default"].createElement(MonacoEditor__default["default"], _extends({
    height: "70vh"
  }, props, {
    beforeMount: handleBeforeMount,
    onMount: handleMount,
    onChange: handleChange,
    options: _objectSpread2({
      glyphMargin: true
    }, props.options),
    language: "graphql",
    defaultValue: props.defaultValue || props.schema
  }));
}

var SchemaEditor = /*#__PURE__*/React.forwardRef(BaseSchemaEditor);

/*
 * `monaco-editor` throws an error while importing languages enums - Error: PostCSS plugin autoprefixer requires PostCSS 8
 *
 * import { languages } from 'monaco-editor'
 * languages.CompletionItemKind
 * languages.CompletionItemInsertTextRule
 *
 * So I hardcoded them inside this file
 */
var CompletionItemKind;

(function (CompletionItemKind) {
  CompletionItemKind[CompletionItemKind["Method"] = 0] = "Method";
  CompletionItemKind[CompletionItemKind["Function"] = 1] = "Function";
  CompletionItemKind[CompletionItemKind["Constructor"] = 2] = "Constructor";
  CompletionItemKind[CompletionItemKind["Field"] = 3] = "Field";
  CompletionItemKind[CompletionItemKind["Variable"] = 4] = "Variable";
  CompletionItemKind[CompletionItemKind["Class"] = 5] = "Class";
  CompletionItemKind[CompletionItemKind["Struct"] = 6] = "Struct";
  CompletionItemKind[CompletionItemKind["Interface"] = 7] = "Interface";
  CompletionItemKind[CompletionItemKind["Module"] = 8] = "Module";
  CompletionItemKind[CompletionItemKind["Property"] = 9] = "Property";
  CompletionItemKind[CompletionItemKind["Event"] = 10] = "Event";
  CompletionItemKind[CompletionItemKind["Operator"] = 11] = "Operator";
  CompletionItemKind[CompletionItemKind["Unit"] = 12] = "Unit";
  CompletionItemKind[CompletionItemKind["Value"] = 13] = "Value";
  CompletionItemKind[CompletionItemKind["Constant"] = 14] = "Constant";
  CompletionItemKind[CompletionItemKind["Enum"] = 15] = "Enum";
  CompletionItemKind[CompletionItemKind["EnumMember"] = 16] = "EnumMember";
  CompletionItemKind[CompletionItemKind["Keyword"] = 17] = "Keyword";
  CompletionItemKind[CompletionItemKind["Text"] = 18] = "Text";
  CompletionItemKind[CompletionItemKind["Color"] = 19] = "Color";
  CompletionItemKind[CompletionItemKind["File"] = 20] = "File";
  CompletionItemKind[CompletionItemKind["Reference"] = 21] = "Reference";
  CompletionItemKind[CompletionItemKind["Customcolor"] = 22] = "Customcolor";
  CompletionItemKind[CompletionItemKind["Folder"] = 23] = "Folder";
  CompletionItemKind[CompletionItemKind["TypeParameter"] = 24] = "TypeParameter";
  CompletionItemKind[CompletionItemKind["User"] = 25] = "User";
  CompletionItemKind[CompletionItemKind["Issue"] = 26] = "Issue";
  CompletionItemKind[CompletionItemKind["Snippet"] = 27] = "Snippet";
})(CompletionItemKind || (CompletionItemKind = {}));

var CompletionItemInsertTextRule;

(function (CompletionItemInsertTextRule) {
  CompletionItemInsertTextRule[CompletionItemInsertTextRule["KeepWhitespace"] = 1] = "KeepWhitespace";
  CompletionItemInsertTextRule[CompletionItemInsertTextRule["InsertAsSnippet"] = 4] = "InsertAsSnippet";
})(CompletionItemInsertTextRule || (CompletionItemInsertTextRule = {}));

var _excluded = ["schema"];

var lsCIK;

(function (lsCIK) {
  lsCIK[lsCIK["Text"] = 1] = "Text";
  lsCIK[lsCIK["Method"] = 2] = "Method";
  lsCIK[lsCIK["Function"] = 3] = "Function";
  lsCIK[lsCIK["Constructor"] = 4] = "Constructor";
  lsCIK[lsCIK["Field"] = 5] = "Field";
  lsCIK[lsCIK["Variable"] = 6] = "Variable";
  lsCIK[lsCIK["Class"] = 7] = "Class";
  lsCIK[lsCIK["Interface"] = 8] = "Interface";
  lsCIK[lsCIK["Module"] = 9] = "Module";
  lsCIK[lsCIK["Property"] = 10] = "Property";
  lsCIK[lsCIK["Unit"] = 11] = "Unit";
  lsCIK[lsCIK["Value"] = 12] = "Value";
  lsCIK[lsCIK["Enum"] = 13] = "Enum";
  lsCIK[lsCIK["Keyword"] = 14] = "Keyword";
  lsCIK[lsCIK["Snippet"] = 15] = "Snippet";
  lsCIK[lsCIK["Color"] = 16] = "Color";
  lsCIK[lsCIK["File"] = 17] = "File";
  lsCIK[lsCIK["Reference"] = 18] = "Reference";
  lsCIK[lsCIK["Folder"] = 19] = "Folder";
  lsCIK[lsCIK["EnumMember"] = 20] = "EnumMember";
  lsCIK[lsCIK["Constant"] = 21] = "Constant";
  lsCIK[lsCIK["Struct"] = 22] = "Struct";
  lsCIK[lsCIK["Event"] = 23] = "Event";
  lsCIK[lsCIK["Operator"] = 24] = "Operator";
  lsCIK[lsCIK["TypeParameter"] = 25] = "TypeParameter";
})(lsCIK || (lsCIK = {}));

var toCompletionItemKind = function toCompletionItemKind(kind) {
  var _map;

  var CIK = CompletionItemKind;
  var map = (_map = {}, _defineProperty(_map, lsCIK.Text, CIK.Text), _defineProperty(_map, lsCIK.Method, CIK.Method), _defineProperty(_map, lsCIK.Function, CIK.Function), _defineProperty(_map, lsCIK.Constructor, CIK.Constructor), _defineProperty(_map, lsCIK.Field, CIK.Field), _defineProperty(_map, lsCIK.Variable, CIK.Variable), _defineProperty(_map, lsCIK.Class, CIK.Class), _defineProperty(_map, lsCIK.Interface, CIK.Interface), _defineProperty(_map, lsCIK.Module, CIK.Module), _defineProperty(_map, lsCIK.Property, CIK.Property), _defineProperty(_map, lsCIK.Unit, CIK.Unit), _defineProperty(_map, lsCIK.Value, CIK.Value), _defineProperty(_map, lsCIK.Enum, CIK.Enum), _defineProperty(_map, lsCIK.Keyword, CIK.Keyword), _defineProperty(_map, lsCIK.Snippet, CIK.Snippet), _defineProperty(_map, lsCIK.Color, CIK.Color), _defineProperty(_map, lsCIK.File, CIK.File), _defineProperty(_map, lsCIK.Reference, CIK.Reference), _defineProperty(_map, lsCIK.Folder, CIK.Folder), _defineProperty(_map, lsCIK.EnumMember, CIK.EnumMember), _defineProperty(_map, lsCIK.Constant, CIK.Constant), _defineProperty(_map, lsCIK.Struct, CIK.Struct), _defineProperty(_map, lsCIK.Event, CIK.Event), _defineProperty(_map, lsCIK.Operator, CIK.Operator), _defineProperty(_map, lsCIK.TypeParameter, CIK.TypeParameter), _map);
  return map[kind] || CIK.Text;
};

var toCompletion = function toCompletion(entry) {
  var _entry$insertText;

  return {
    range: entry.range,
    kind: toCompletionItemKind(entry.kind),
    label: entry.label,
    insertText: (_entry$insertText = entry.insertText) !== null && _entry$insertText !== void 0 ? _entry$insertText : entry.label,
    insertTextRules: entry.insertText ? CompletionItemInsertTextRule.InsertAsSnippet : undefined,
    sortText: entry.sortText,
    filterText: entry.filterText,
    documentation: entry.documentation,
    detail: entry.detail,
    command: entry.command
  };
};

var GraphQLWorker = /*#__PURE__*/function () {
  function GraphQLWorker() {
    _classCallCheck(this, GraphQLWorker);
  }

  _createClass(GraphQLWorker, [{
    key: "doComplete",
    value: function doComplete(documentModel, position, schema) {
      var _this = this;

      var document = documentModel.getValue();

      if (!document) {
        console.log('no document');
        return [];
      }

      if (!schema) {
        console.log('no schema');
      }

      var graphQLPosition = toGraphQLPosition(position);
      var suggestions = graphqlLanguageService.getAutocompleteSuggestions(schema, document, graphQLPosition);
      return suggestions.map(function (suggestion) {
        return _this.toCompletion(suggestion);
      });
    }
  }, {
    key: "toCompletion",
    value: function toCompletion(entry, range) {
      return {
        label: entry.label,
        insertText: entry.insertText,
        insertTextFormat: entry.insertTextFormat,
        sortText: entry.sortText,
        filterText: entry.filterText,
        documentation: entry.documentation,
        detail: entry.detail,
        range: range ? toMonacoRange(range) : undefined,
        kind: entry.kind,
        command: entry.command ? _objectSpread2(_objectSpread2({}, entry.command), {}, {
          id: entry.command.command
        }) : undefined
      };
    }
  }]);

  return GraphQLWorker;
}();

var ExecutableDocumentEditor = function ExecutableDocumentEditor(_ref) {
  var schema = _ref.schema,
      editorProps = _objectWithoutProperties(_ref, _excluded);

  var monaco = MonacoEditor.useMonaco();

  var _useState = React.useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      completionProvider = _useState2[0],
      setCompletionProvider = _useState2[1];

  var editorUriRef = React.useRef();
  React.useEffect(function () {
    if (!monaco || !schema) {
      return;
    }

    if (completionProvider) {
      // dispose instance to prevent having duplicated field
      completionProvider.dispose();
    }

    var newProvider = monaco.languages.registerCompletionItemProvider('graphql', {
      triggerCharacters: [':', '$', '\n', ' ', '(', '@'],
      provideCompletionItems: function provideCompletionItems(model, position) {
        var isUriEquals = model.uri.path === editorUriRef.current.path;

        if (!isUriEquals) {
          return {
            suggestions: []
          };
        }

        var worker = new GraphQLWorker();
        var completionItems = worker.doComplete(model, position, schema);
        return {
          incomplete: true,
          suggestions: completionItems.map(function (item) {
            return toCompletion(item);
          })
        };
      }
    });
    setCompletionProvider(newProvider);
  }, [monaco, schema]);
  return /*#__PURE__*/React__default["default"].createElement(MonacoEditor__default["default"], _extends({
    height: "70vh"
  }, editorProps, {
    language: "graphql",
    onMount: function onMount(editor) {
      editorUriRef.current = editor.getModel().uri;
    }
  }));
};

Object.defineProperty(exports, 'getRange', {
  enumerable: true,
  get: function () { return graphqlLanguageService.getRange; }
});
exports.EnrichedLanguageService = EnrichedLanguageService;
exports.ExecutableDocumentEditor = ExecutableDocumentEditor;
exports.SchemaEditor = SchemaEditor;
exports.coreDefinitionSource = coreDefinitionSource;
exports.coreDiagnosticsSource = coreDiagnosticsSource;
exports.coreHoverSource = coreHoverSource;
exports.debugHoverSource = debugHoverSource;
exports.emptyLocation = emptyLocation;
exports.locToRange = locToRange;
exports.removeFalsey = removeFalsey;
exports.showWidgetInPosition = showWidgetInPosition;
exports.toGraphQLPosition = toGraphQLPosition;
exports.toMarkerData = toMarkerData;
exports.toMonacoRange = toMonacoRange;
//# sourceMappingURL=index.js.map
